/*
 * ActiveConnectionDialog.java
 *
 *  iReport  --  Visual designer for generating JasperReports Documents
 *  Copyright (C) 2002-2003  Giulio Toffoli gt@businesslogic.it
 *
 *  This program is free software; you can redistribute  and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Giulio Toffoli
 *  Via T.Aspetti, 233
 *  35100 Padova ITALY
 *  gt@businesslogic.it
 *
 *
 * Created on 5 giugno 2003, 23.40
 */

package it.businesslogic.ireport.gui;
import it.businesslogic.ireport.*;
import it.businesslogic.ireport.util.*;

import javax.swing.*;
import java.util.*;

/**
 *
 * @author  Administrator
 */
public class ActiveConnectionDialog extends javax.swing.JDialog {
    
    /** Creates new form ActiveConnectionDialog */
    public ActiveConnectionDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        Misc.centerFrame(this);
         
        DefaultListModel lm = new DefaultListModel();
        this.jListConnections.setModel(lm );

	Enumeration e = ((MainFrame)parent).getConnections().elements();
        
        while (e.hasMoreElements())
        {
            lm.addElement(e.nextElement());
        }
        
        if (((MainFrame)parent).getProperties().get("DefaultConnection") != null)
        {
            jListConnections.setSelectedValue( ((MainFrame)parent).getProperties().get("DefaultConnection"), true);
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
        private void initComponents() {//GEN-BEGIN:initComponents
                java.awt.GridBagConstraints gridBagConstraints;

                jScrollPane1 = new javax.swing.JScrollPane();
                jListConnections = new javax.swing.JList();
                jLabel1 = new javax.swing.JLabel();
                jPanel1 = new javax.swing.JPanel();
                jButtonOK = new javax.swing.JButton();
                jButtonCancel = new javax.swing.JButton();

                getContentPane().setLayout(new java.awt.GridBagLayout());

                setTitle("Set active connection...");
                setResizable(false);
                setModal(true);
                addWindowListener(new java.awt.event.WindowAdapter() {
                        public void windowClosing(java.awt.event.WindowEvent evt) {
                                closeDialog(evt);
                        }
                });

                jListConnections.setFont(new java.awt.Font("Tahoma", 0, 11));
                jListConnections.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
                        public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                                jListConnectionsValueChanged(evt);
                        }
                });

                jScrollPane1.setViewportView(jListConnections);

                gridBagConstraints = new java.awt.GridBagConstraints();
                gridBagConstraints.gridx = 0;
                gridBagConstraints.gridy = 1;
                gridBagConstraints.gridheight = 3;
                gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
                gridBagConstraints.insets = new java.awt.Insets(3, 5, 3, 3);
                gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
                gridBagConstraints.weightx = 1000.0;
                getContentPane().add(jScrollPane1, gridBagConstraints);

                jLabel1.setFont(new java.awt.Font("Tahoma", 0, 11));
                jLabel1.setText("Available connections");
                gridBagConstraints = new java.awt.GridBagConstraints();
                gridBagConstraints.gridx = 0;
                gridBagConstraints.gridy = 0;
                gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
                gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
                gridBagConstraints.insets = new java.awt.Insets(3, 5, 3, 3);
                getContentPane().add(jLabel1, gridBagConstraints);

                jPanel1.setLayout(new java.awt.GridBagLayout());

                jButtonOK.setFont(new java.awt.Font("Tahoma", 0, 11));
                jButtonOK.setText("OK");
                jButtonOK.setMnemonic('o');
                jButtonOK.setEnabled(false);
                jButtonOK.addActionListener(new java.awt.event.ActionListener() {
                        public void actionPerformed(java.awt.event.ActionEvent evt) {
                                jButtonOKActionPerformed(evt);
                        }
                });

                gridBagConstraints = new java.awt.GridBagConstraints();
                gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
                gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
                gridBagConstraints.insets = new java.awt.Insets(3, 0, 0, 0);
                jPanel1.add(jButtonOK, gridBagConstraints);

                jButtonCancel.setFont(new java.awt.Font("Tahoma", 0, 11));
                jButtonCancel.setText("Cancel");
                jButtonCancel.setMnemonic('c');
                jButtonCancel.addActionListener(new java.awt.event.ActionListener() {
                        public void actionPerformed(java.awt.event.ActionEvent evt) {
                                jButtonCancelActionPerformed(evt);
                        }
                });

                gridBagConstraints = new java.awt.GridBagConstraints();
                gridBagConstraints.gridx = 0;
                gridBagConstraints.gridy = 1;
                gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
                gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
                gridBagConstraints.weightx = 1.0;
                gridBagConstraints.weighty = 1.0;
                gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 0);
                jPanel1.add(jButtonCancel, gridBagConstraints);

                gridBagConstraints = new java.awt.GridBagConstraints();
                gridBagConstraints.gridx = 1;
                gridBagConstraints.gridy = 0;
                gridBagConstraints.gridheight = 2;
                gridBagConstraints.fill = java.awt.GridBagConstraints.VERTICAL;
                gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
                gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHEAST;
                gridBagConstraints.weightx = 1.0;
                gridBagConstraints.weighty = 1.0;
                getContentPane().add(jPanel1, gridBagConstraints);

                pack();
        }//GEN-END:initComponents

    private void jButtonCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCancelActionPerformed
        this.setDialogResult(JOptionPane.CANCEL_OPTION);
        this.setVisible(false);
        this.dispose();
    }//GEN-LAST:event_jButtonCancelActionPerformed

    private void jListConnectionsValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_jListConnectionsValueChanged
        if (jListConnections.getSelectedValue() != null)
            jButtonOK.setEnabled(true);
        else
            jButtonOK.setEnabled(false);
    }//GEN-LAST:event_jListConnectionsValueChanged

    private void jButtonOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonOKActionPerformed
       iReportConnection = (IReportConnection)jListConnections.getSelectedValue();
       this.setVisible(false);
       this.setDialogResult(JOptionPane.OK_OPTION);
       this.dispose();
    }//GEN-LAST:event_jButtonOKActionPerformed
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        this.setDialogResult(JOptionPane.CLOSED_OPTION);
        dispose();
    }//GEN-LAST:event_closeDialog
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        new ActiveConnectionDialog(new javax.swing.JFrame(), true).show();
    }
    
    /** Getter for property iReportConnection.
     * @return Value of property iReportConnection.
     *
     */
    public IReportConnection getIReportConnection() {
        return iReportConnection;
    }    
    
    /** Setter for property iReportConnection.
     * @param iReportConnection New value of property iReportConnection.
     *
     */
    public void setIReportConnection(IReportConnection iReportConnection) {
        this.iReportConnection = iReportConnection;
    }
    
    /** Getter for property dialogResult.
     * @return Value of property dialogResult.
     *
     */
    public int getDialogResult() {
        return dialogResult;
    }
    
    /** Setter for property dialogResult.
     * @param dialogResult New value of property dialogResult.
     *
     */
    public void setDialogResult(int dialogResult) {
        this.dialogResult = dialogResult;
    }
    
        // Variables declaration - do not modify//GEN-BEGIN:variables
        private javax.swing.JButton jButtonCancel;
        private javax.swing.JButton jButtonOK;
        private javax.swing.JLabel jLabel1;
        private javax.swing.JList jListConnections;
        private javax.swing.JPanel jPanel1;
        private javax.swing.JScrollPane jScrollPane1;
        // End of variables declaration//GEN-END:variables

    private IReportConnection iReportConnection;    
    
    private int dialogResult;
    
}
